about summary refs log tree commit diff
path: root/third_party/git/ci/run-static-analysis.sh
diff options
context:
space:
mode:
Diffstat (limited to 'third_party/git/ci/run-static-analysis.sh')
-rwxr-xr-xthird_party/git/ci/run-static-analysis.sh32
1 files changed, 32 insertions, 0 deletions
diff --git a/third_party/git/ci/run-static-analysis.sh b/third_party/git/ci/run-static-analysis.sh
new file mode 100755
index 0000000000..65bcebda41
--- /dev/null
+++ b/third_party/git/ci/run-static-analysis.sh
@@ -0,0 +1,32 @@
+#!/bin/sh
+#
+# Perform various static code analysis checks
+#
+
+. ${0%/*}/lib.sh
+
+make coccicheck
+
+set +x
+
+fail=
+for cocci_patch in contrib/coccinelle/*.patch
+do
+	if test -s "$cocci_patch"
+	then
+		echo "$(tput setaf 1)Coccinelle suggests the following changes in '$cocci_patch':$(tput sgr0)"
+		cat "$cocci_patch"
+		fail=UnfortunatelyYes
+	fi
+done
+
+if test -n "$fail"
+then
+	echo "$(tput setaf 1)error: Coccinelle suggested some changes$(tput sgr0)"
+	exit 1
+fi
+
+make hdr-check ||
+exit 1
+
+save_good_tree